Page MenuHomePhabricator

SemanticDrilldown does not recognize property type external identifier.
Closed, ResolvedPublic

Description

When a filter uses a property of type external identifier [1], an error message is displayed on top tof the drilldown page.

"Error! Unsupported property type (External identifier) for filter XY.Error!"

As the property type holds text values it should be treated as a text property for the filer.

[1] https://www.semantic-mediawiki.org/wiki/Help:Type_External_identifier

Event Timeline

Krabina created this task.Oct 16 2017, 2:11 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 16 2017, 2:11 PM
Aklapper removed Yaron_Koren as the assignee of this task.Jun 19 2020, 4:13 PM
Aklapper added a subscriber: Yaron_Koren.

This task has been assigned to the same task owner for more than two years. Resetting task assignee due to inactivity, to decrease task cookie-licking and to get a slightly more realistic overview of plans. Please feel free to assign this task to yourself again if you still realistically work or plan to work on this task - it would be welcome!

For tips how to manage individual work in Phabricator (noisy notifications, lists of task, etc.), see https://phabricator.wikimedia.org/T228575#6237124 for available options.
(For the records, two emails were sent to assignee addresses before resetting assignees. See T228575 for more info and for potential feedback. Thanks!)

Ivanhercaz added a subscriber: Ivanhercaz.

I will take a look, @Krabina!

Change 633325 had a related patch set uploaded (by Ivanhercaz; owner: Ivanhercaz):
[mediawiki/extensions/SemanticDrilldown@master] Recognize data type "external identifier"

https://gerrit.wikimedia.org/r/633325

While I can confirm that after applying the patch, the error message is gone, the filter in Special:BrowseData remains empty. (Before that the filter worked, but the error message was displayed).
BTW I just realized that the same behaviour shows up not only in properties of type external identifyer, but also in properties of type quantity.

Correction, my mistake. The patch is working fine. Maybe you can add this for type quantity as well?

(Before that the filter worked, but the error message was displayed).

In my case, without this patch I don't the see the values in the filter: it shows the filter without values.

Correction, my mistake. The patch is working fine. Maybe you can add this for type quantity as well?

Yes, I think I can fix the issues for the another data types in which this error is shown.

Maybe some can be treated the same in drilldown:
https://www.semantic-mediawiki.org/wiki/Help:List_of_datatypes
e. g.

  • external identifier, URL and Annotation URI are basically the same (at least for filtering)
  • quantity, temperature are probably the same as number
  • code, monolingual text, keyword, e-mail and telephone number are the same as text
  • reference and record might be trickier if you wanted to be able to have sub-filters for the "has fields" annotations

Is there any point to having filtering for the property types "External identifier", "URL", "Code", "Email", etc.? It seems to me that, for all of these types, every value will be more or less unique, and thus there's no point to adding them to Special:BrowseData, which is based on aggregation.

Why would you think that? I agree that it is not very likely, but if you have a lot of data (imagine a company database, e. g.), you might want to filter for all entries with the same URL or e-mail.

At least in my possible use cases and the ones I am interested, I think it is very useful to allow filter by:

  • Quantity, temperature are probably the same as number. It is possible to have the same data for different pages.
  • Email, telephone and keyword. I understand email and telephone may be more unique than less, but depending of the use case it may be useful to filter. Keyword is very useful to filter.

I can perform the necessary changes to the patch I commit to Semantic Drilldown in Gerrit, but it is very important to confirm what should be filter or not, because the another option might be allow to filter any data type and let the users decide, although it may cause some problems with some datatypes, at least in my opinion.

Change 633325 merged by jenkins-bot:
[mediawiki/extensions/SemanticDrilldown@master] Recognize data type "external identifier"

https://gerrit.wikimedia.org/r/633325

Ivanhercaz closed this task as Resolved.Oct 12 2020, 6:19 PM

This issue is solved by the patch I commited, however it would be interesting what should be do with the another datatypes. Should it be supported by Semantic Drilldown?

I agree that Quantity and Temperature would be great to be able to filter on. This requires a lot of unit handling, and I hope someone can implement these.

I had no idea that there was a "Keyword" datatype. It looks like it was added about two years ago. Kind of strange, but it would be great to able to filter on this as well.

Email, Telephone, URL, External identifier, etc. seem very strange to filter on, and I don't think anyone has ever asked for filtering capabilities for these before. On the other hand, I don't use Semantic Drilldown, so I shouldn't really care. :) I checked in the "External identifier" patch earlier today.

I agree that Quantity and Temperature would be great to be able to filter on. This requires a lot of unit handling, and I hope someone can implement these.

I had no idea that there was a "Keyword" datatype. It looks like it was added about two years ago. Kind of strange, but it would be great to able to filter on this as well.

I will try it when I have some free time to dedicate it.

Email, Telephone, URL, External identifier, etc. seem very strange to filter on, and I don't think anyone has ever asked for filtering capabilities for these before. On the other hand, I don't use Semantic Drilldown, so I shouldn't really care. :) I checked in the "External identifier" patch earlier today.

But just to know if I should bother you if I contribute with a patch: are you still maintaining Semantic Drilldown? If not let me know to not bother you with mentions in Gerrit 😟 .

Why would you think that? I agree that it is not very likely, but if you have a lot of data (imagine a company database, e. g.), you might want to filter for all entries with the same URL or e-mail.

I am agree with that. URL or emails are not necessary to be just in one page.

I am still the maintainer of Semantic Drilldown, although I really shouldn't be any more. I've been meaning to pass it off for a long time now.

I am still the maintainer of Semantic Drilldown, although I really shouldn't be any more. I've been meaning to pass it off for a long time now.

Ups, excuse me, Yaron. I though I replied you. Thanks for the information about Semantic Drilldown.